if SERVER then
  util.AddNetworkString("Propplacer.Place")
  local function PropplacerPlaceCallback(length, player)
    print(("Received message of length " .. length .. " from player " .. player:GetName()))
    do
      local model_file = net.ReadString()
      local pos = net.ReadVector()
      local angle = net.ReadAngle()
      print("Spawn model ", model_file)
      do
        local ent = ents.Create("prop_physics")
        if IsValid(ent) then
          ent:SetModel(model_file)
          ent:SetPos(pos)
          ent:SetAngles(angle)
          ent:Spawn()
	  local physx = ent:GetPhysicsObject()
	  if physx and physx:IsValid() then
            physx:EnableMotion(false)
          end
          cleanup.Add(player, "props", ent)
          undo.Create(("Spawned " .. model_file))
          undo.AddEntity(ent)
          undo.SetPlayer(player)
          return undo.Finish()
        end
      end
    end
  end
  do local _ = PropplacerPlaceCallback end
  return net.Receive("Propplacer.Place", PropplacerPlaceCallback)
end
